package sun.net.httpserver;

import java.io.IOException;
import java.io.OutputStream;

class PlaceholderOutputStream extends OutputStream
{
    OutputStream wrapped;
    
    PlaceholderOutputStream(OutputStream wrapped) {
        this.wrapped = wrapped;
    }
    
    void setWrappedStream(OutputStream wrapped) {
        this.wrapped = wrapped;
    }
    
    boolean isWrapped() {
        return this.wrapped != null;
    }
    
    private void checkWrap() throws IOException {
        if (this.wrapped == null) {
            throw new IOException("response headers not sent yet");
        }
        return;
    }
    
    @Override
    public void write(int n) throws IOException {
        this.checkWrap();
        this.wrapped.write(n);
    }
    
    @Override
    public void write(byte[] b) throws IOException {
        this.checkWrap();
        this.wrapped.write(b);
    }
    
    @Override
    public void write(byte[] b, int off, int len) throws IOException {
        this.checkWrap();
        this.wrapped.write(b, off, len);
    }
    
    @Override
    public void flush() throws IOException {
        this.checkWrap();
        this.wrapped.flush();
    }
    
    @Override
    public void close() throws IOException {
        this.checkWrap();
        this.wrapped.close();
    }
}
